	device zxspectrum128
;        ORG #4000
; incbin "pixel0.scr"
        ORG #6000
begin
	
	ld a,$10,bc,$7ffd:out (c),a
	out ($FE),a
	call blacks

;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir

		ld ix,me1
		call to
		call to
		call to
		call to
;check keys
ks:
	ld hl,keyt
	ld c,0
klp:
	ld a,(hl):inc hl
	ld d,(hl):inc hl
	in a,($FE)
	and d
	jp z,gs
	inc c
	ld a,c
	cp 10
	jp nz,klp
	jp ks
gs:
	ld a,c
	ld (ln),a
games:
	call blacks
;depack tile
	ld hl,(ln),h,0
	ld de,pict
	add hl,hl
	add hl,de
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld de,$C000:call dzx7_standard
;draw tile
	ld hl,$C000
	ld de,$4000+4*32+8
	ld a,128
pl1:
	exa
	push de
	ld bc,16
	ldir
	pop de
	call nbde
	exa
	dec a
	jr nz,pl1
;colors
	ld de,$5800+4*32+8
	ld a,16
pl2:
	ld bc,16
	ldir
	ld c,16
	ex de,hl
	add hl,bc
	ex de,hl
	dec a
	jr nz,pl2

;		ld ix,me2
;		call to

;copy picture - dirty hack
	ld hl,$4000,de,$c000,bc,6912:ldir

;wait:
	ld bc,150
wai:
	ei
	halt
	dec bc
	ld a,b
	or c
	jr nz,wai

; swap test
;;	ld hl,$4000+4*32+8
;;	ld de,$4000+4*32+8+4
;;	call swap;attributes calc inside
;	exx
;	ld hl,$5800+4*32+8
;	ld de,$5800+4*32+8+4
;	exx
;	call swap

	call mix

;---------------------------------
	xor a
	ld (pre+1),a
	ld (cxy),a
	ld (cxy+1),a
	call xorb

glp:
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	ei:halt:halt
pre: ld a,0
	call xorb
	ld a,(pre+1)
	inc a
	and 3
	ld (pre+1),a
	call xorb
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ld de,(cxy)
 ld a,$F7:in a,(#FE):and 16:jp z,left;5 is left
;O
 ld a,$DF:in a,(#FE):and 2:jp z,left

 ld a,$EF:in a,(#FE):and 4:jp z,right;8 is right
;P
 ld a,$DF:in a,(#FE):and 1:jp z,right

 ld a,$EF:in a,(#FE):and 8:jp z,up;7 is up
;Q
 ld a,$FB:in a,(#FE):and 1:jp z,up

 ld a,$EF:in a,(#FE):and 16:jp z,down;6 is down
;A
 ld a,$FD:in a,(#FE):and 1:jp z,down

; Fire
;;0
;	ld a,$EF:in a,($FE):and 1:jp z,fire
;;En
;	ld a,$BF:in a,($FE):and 1:jp z,fire
;;Sp
;	ld a,$7F:in a,($FE):and 1:jp z,fire
;;M
;	ld a,$7F:in a,($FE):and 4:jp z,fire

	jp glp

left:
;E(x)=0?
	inc e
	dec e
	jp z,glp
	
;?fire pressed?
	call tfire
	jp z,lsw
	ld a,(pre+1)
	call xorb
	dec e
	jp kend
lsw:
	ld a,(pre+1)
	call xorb
	call charxy
	push hl
	dec e
	call charxy
	ex de,hl
	pop hl
	ei:halt
	call swap
	
	call check
	jp nz,wlf
leveln:
	ld a,(ln)
	inc a
	cp 10
	jr nz,noll
	xor a
noll:
	ld (ln),a

	ld b,50
bli:
	ei:halt
	ld ix,me2
	push bc
	call to
	pop bc
	djnz bli

	jp games

wlf:
	call wp;tfire
;	jr nz,wlf
	ld de,(cxy)
	jp kend

right:
	ld a,e
	cp 3
	jp z,glp
;?fire pressed?	
	call tfire
	jp z,rsw
	ld a,(pre+1)
	call xorb
	inc e
kend:
	ld (cxy),de
	ld a,(pre+1)
	call xorb
	ei
	halt:halt
	halt:halt
	jp glp
rsw:
	ld a,(pre+1)
	call xorb
	call charxy
	push hl
	inc e
	call charxy
	ex de,hl
	pop hl
	ei:halt
	call swap
	call check
	jp z,leveln
wrf:
	call wp;tfire
;	jr z,wrf
	ld de,(cxy)
	jp kend
up:
;D(y)=0?
	inc d
	dec d
	jp z,glp
;?fire pressed?
	call tfire
	jp z,usw
	ld a,(pre+1)
	call xorb
	dec d
	jp kend
usw:
	ld a,(pre+1)
	call xorb
	call charxy
	push hl
	dec d
	call charxy
	ex de,hl
	pop hl
	ei:halt
	call swap
	call check
	jp z,leveln
wuf:
	call wp;tfire
;	jr z,wuf
	ld de,(cxy)
	jp kend

down:

	ld a,d
	cp 3
	jp z,glp
;?fire pressed?
	call tfire
	jp z,dsw
	ld a,(pre+1)
	call xorb
	inc d
	jp kend
dsw:
	ld a,(pre+1)
	call xorb
	call charxy
	push hl
	inc d
	call charxy
	ex de,hl
	pop hl
	ei:halt
	call swap
	call check
	jp z,leveln
wdf:
	call wp;tfire
;	jr z,wdf
	ld de,(cxy)
	jp kend
;###################################################
check: ;check if images equal
	ld hl,$4000+4*32+8
	ld de,$C000+4*32+8
	ld c,128
che1:
	push de,hl
	ld b,16
che2:
	ld a,(de):cp (hl):jp nz,exit_check
	inc hl,de
	djnz che2

	pop hl,de
	call nbhl
	call nbde
	dec c
	jp nz,che1 ; Z=0
	ret
exit_check: ; Z=1
	pop hl,de
	ret
;###################################################
blacks:
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
    ret

tfire:
;0
	ld a,$EF:in a,($FE):and 1:ret z;jp z,fire
;M
	ld a,$7F:in a,($FE):and 4;:jp z,fire
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
charxy: ;calc screen adres with chars in D.E=y.x
	push de
	ld a,e
	add a,a
	add a,a
	add a,8
	ld e,a

	ld a,d
	add a,a
	add a,a
	add a,4
	ld d,a

		ld	hl, 4000h
		ld	a, d
		and	18h
		or	h
		ld	h, a
		ld	a, d
		and	7
		ld	d, a
		srl	d
		rr	l
		srl	d
		rr	l
		srl	d
		rr	l
		add	hl, de

	pop de
	ret

xorb:
	push de

	ld h,a,l,0
	srl h
	rr l
	ld de,bord
	add hl,de
;	ld de,$4800+4*32;+8
	ld de,(cxy)
	push hl
	call charxy
	ex de,hl
	pop hl
	ld b,32
b1:
	ld c,e
 dup 4
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl,e
edup
	ld e,c
	call nbde
	djnz b1

	pop de
	ret

wk:;wait keypressed
	xor a
	in a,($fe)
	cpl
	and 31
	jr z,wk
	ret
wp: ;wait until pressed
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,wp
	ret

;******************************************************
swap:
;calc attributes
	push hl,de
	exx
;: DE=
;: HL= 
;$40=010 00 000
;$48=010 01 000
;$50=010 10 000

;$58=010110 00
;$59=010110 01
;$5A=010110 10
	pop de
	ld a,d
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld d,a

	pop hl
	ld a,h
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	exx
;go
	ld a,4
sw3:
	push af
	push hl,de
	ld a,4
sw2:
	push af
	push de,hl

	ld b,8
sw1:
	ld c,(hl)
	ld a,(de)
	ld (hl),a
	ld a,c
	ld (de),a
	inc h
	inc d
	djnz sw1

	pop hl,de
	inc e,l

	exx
	ld c,(hl)
	ld a,(de)
	ld (hl),a
	ld a,c
	ld (de),a
	inc e,l
	exx

	pop af
	dec a
	jp nz,sw2

	pop de,hl
	ld a,e
	add a,32
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a

	ld a,l
	add a,32
	ld l,a
	sbc a,a
	and 8
	add a,h
	ld h,a

	exx
	ld bc,28
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	exx

	pop af
	dec a
	jp nz,sw3

	ret

mix:
	ld a,16
m0:
	push af
m1:
	call random
	and 15
	ld c,a

	call random
	and 15
	ld b,a
;no need to swap equal
	cp c
	jp z,m1
;mix tiles
	ld a,c
	and 3
	ld e,a
	srl c
	srl c
	ld d,c
	call charxy
	push hl

	ld a,b
	and 3
	ld e,a
	srl b
	srl b
	ld d,b
	call charxy
	ex de,hl
	pop hl

	call swap

	pop af
	dec a
	jp nz,m0
	ret

random: ;A=random number
	push hl,de
seed: ld hl,12345
  ; hl ^= hl << 5
  ld d,h
  ld a,l
  add hl,hl
  add hl,hl
  add hl,hl
  add hl,hl
  add hl,hl
  xor l
  ld l,a
  ld a,d
  xor h
  ld h,a
  ; hl ^= hl >> 9
  rra
  xor l
  ld l,a
  ; hl ^= hl <<8
  xor h
  ld h,a
  ld (seed+1),hl
  pop de,hl
  ret

to: ;IX=data
	ld e,(ix+0):inc ix
	ld d,(ix+0):inc ix
	ld a,(ix+0):inc ix
	ld (tc+1),a
tol:
	ld a,(ix+0):inc ix
	or a:ret z
	ld h,0,l,a
	ld bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	push de
	ld b,8
ch8:
;	ld a,(hl),(de),a
	ld a,(de)
	xor (hl)
	ld (de),a
	inc hl,d
	djnz ch8
	pop de
;put color
	ld a,d
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	ld l,e
tc: ld (hl),0
	inc e
	jp tol
me1:
	dw $4800+3
	db 7
	db "Pixteen by g0blinish,2019",0

	dw $4840+5
	db 6
	db "Controls:cursor,qaopm",0
	
	dw $4880+6
	db 5
	db "fire for swap tiles",0

	dw $48C0+2
	db 7
	db "Press 0-9 for choose picture",0
me2:
	dw $4000+3*32+8
	db 7
	db "congratulations!",0
;******************************************************
;;;;;;;;;;;;; V A R I A B L E S ;;;;;;;;;;;;;
cxy:dw 0
ln: db 0

nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET
nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET

zx7:include "zx7.a80"
fnt:incbin "xeno.fnt"
bord: incbin "bord2.bin"
pict:
	dw p1,p2,p3,p4,p5
	dw p6,p7,p8,p9,p10
keyt:
	db $EF,1 ;0

	db #F7,1;1
	db #F7,2;2
	db #F7,4;3
	db #F7,8;4
	db #F7,16;5

	db $EF,16;6
	db $EF,8;7
	db $EF,4;8
	db $EF,2;9

p1:incbin "p1.bin.zx7"
p2:incbin "p0.bin.zx7"
p3:incbin "p2.bin.zx7"
p4:incbin "p3.bin.zx7"
p5:incbin "p4.bin.zx7"
p6:incbin "p5.bin.zx7"
p7:incbin "p6.bin.zx7"
p8:incbin "p7.bin.zx7"
p9:incbin "p9.bin.zx7"
p10:incbin "p10.bin.zx7"

end
	display end
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "pixt.code",begin,end-begin
